unit DeviceFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons, WaveOut, MMSystem;

type
  TDeviceForm = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Panel2: TPanel;
    ComboBox2: TComboBox;
    Panel3: TPanel;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    Panel4: TPanel;
    TrackBar1: TTrackBar;
    Panel5: TPanel;
    TrackBar2: TTrackBar;
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure ComboBox1DropDown(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
  public
    procedure Execute(AWaveOut:TWaveOut);
  end;

var
  DeviceForm: TDeviceForm;

implementation

uses WaveBase;

{$R *.dfm}

{ TDeviceForm }

procedure TDeviceForm.Execute(AWaveOut: TWaveOut);
const
  T:array[False..True] of Integer=(0,1);
var
  p,u:Boolean;
  v,c:Integer;
begin
  p:=AWaveOut.Playing;
  AWaveOut.Playing:=False;
  try
    ComboBox1DropDown(nil);
    ComboBox1.ItemIndex:=1+AWaveOut.DeviceID;
    ComboBox2.Text:=IntToStr(AWaveOut.Frequency);
    RadioGroup1.ItemIndex:=T[AWaveOut.Stereo];
    RadioGroup2.ItemIndex:=T[AWaveOut.bits16];
    TrackBar1.Position:=AWaveOut.BufferCount;
    TrackBar1Change(nil);
    v:=Round(1000*AWaveOut.BufferSize/AWaveOut.Frequency);
    if AWaveOut.Stereo then
      v:=v div 2;
    if AWaveOut.Bits16 then
      v:=v div 2;
    TrackBar2.Position:=v;
    TrackBar2Change(nil);
    u:=False;
    repeat
      case ShowModal of
        mrOk:begin
          Val(ComboBox2.Text,v,c);
          if (c=0) and (v>=5000) and (v<=100000) then begin
            AWaveOut.DeviceID:=ComboBox1.ItemIndex-1;
            AWaveOut.Frequency:=v;
            AWaveOut.Stereo:=RadioGroup1.ItemIndex>0;
            AWaveOut.Bits16:=RadioGroup2.ItemIndex>0;
            AWaveOut.BufferCount:=TrackBar1.Position;
            v:=Round(4*TrackBar2.Position*Integer(AWaveOut.Frequency)/1000);
            if not AWaveOut.Stereo then
              v:=v div 2;
            if not AWaveOut.Bits16 then
              v:=v div 2;
            AWaveOut.BufferSize:=v;
            u:=True;
          end else
            MessageDlg('La frquence doit tre une valeur entire comprise entre 5000 et 100000.',mtError,[mbOk],0);
        end;
      else
        u:=True;
      end;
    until u;
  finally
    AWaveOut.Playing:=p;
  end;
end;

procedure TDeviceForm.ComboBox1DropDown(Sender: TObject);
var
  a,b:Integer;
  WOC:TWaveOutCaps;
begin
  b:=ComboBox1.ItemIndex;
  ComboBox1.Items.BeginUpdate;
  try
    ComboBox1.Items.Clear;
    ComboBox1.Items.Add('Priphrique par dfaut');
    for a:=0 to waveOutGetNumDevs-1 do begin
      waveOutGetDevCaps(a,@WOC,SizeOf(WOC));
      ComboBox1.Items.Add(WOC.szPname);
    end;
  finally
    ComboBox1.Items.EndUpdate;
  end;
  ComboBox1.ItemIndex:=b;
end;

procedure TDeviceForm.TrackBar1Change(Sender: TObject);
begin
  Panel4.Caption:=Format('Nombre de tampons: %d',[TrackBar1.Position]);
end;

procedure TDeviceForm.TrackBar2Change(Sender: TObject);
begin
  Panel5.Caption:=Format('Longueur des tampons: %d ms',[TrackBar2.Position]);
end;

end.

