unit MainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WaveBase, WaveOut, StdCtrls, CosineTable, ComCtrls, AudioSource,
  ForwardAudioSource, ExtCtrls, Math, ImgList, ActnList, Buttons, DeviceFormUnit,
  WaveFormUnit, XPMan, AboutFormUnit, Menus;

type
  TMainForm = class(TForm)
    WaveOut1: TWaveOut;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    TrackBar1: TTrackBar;
    Panel1: TPanel;
    GroupBox2: TGroupBox;
    ProgressBar1: TProgressBar;
    Panel3: TPanel;
    TrackBar3: TTrackBar;
    GroupBox3: TGroupBox;
    Panel4: TPanel;
    TrackBar4: TTrackBar;
    Panel5: TPanel;
    TrackBar5: TTrackBar;
    Panel6: TPanel;
    TrackBar6: TTrackBar;
    GroupBox5: TGroupBox;
    ImageList1: TImageList;
    SpeedButton1: TSpeedButton;
    ActionList1: TActionList;
    ActionStart: TAction;
    ActionStop: TAction;
    ActionConfigure: TAction;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    ActionTest: TAction;
    XPManifest1: TXPManifest;
    SpeedButton4: TSpeedButton;
    ActionAbout: TAction;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ScrollBox1: TScrollBox;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    ProgressBar2: TProgressBar;
    Panel2: TPanel;
    TrackBar2: TTrackBar;
    GroupBox4: TGroupBox;
    Panel7: TPanel;
    TrackBar7: TTrackBar;
    Panel8: TPanel;
    TrackBar8: TTrackBar;
    Panel9: TPanel;
    TrackBar9: TTrackBar;
    Panel10: TPanel;
    TrackBar10: TTrackBar;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuItemSave: TMenuItem;
    MenuDevice: TMenuItem;
    MenuItemTest: TMenuItem;
    MenuItemStartStop: TMenuItem;
    MenuItemConfigure: TMenuItem;
    ActionExport: TAction;
    SaveDialog1: TSaveDialog;
    MenuHelp: TMenuItem;
    MenuItemAbout: TMenuItem;
    procedure WaveOut1Buffer(Buffer: Pointer; Length: Cardinal;
      BufferQueueLength: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure ActionStartExecute(Sender: TObject);
    procedure ActionStopExecute(Sender: TObject);
    procedure ActionConfigureExecute(Sender: TObject);
    procedure ActionTestExecute(Sender: TObject);
    procedure ActionAboutExecute(Sender: TObject);
    procedure WaveOut1Start(Sender: TObject);
    procedure WaveOut1Stop(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionExportExecute(Sender: TObject);
  private
    FSource:TForwardAudioSource;
    FBitmap:TBitmap;
  public
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

{ TForm1 }

procedure TMainForm.WaveOut1Buffer(Buffer: Pointer; Length: Cardinal;
  BufferQueueLength: Integer);
begin
  with WaveOut1 do
    FSource.Render(Buffer,Length,Frequency,Stereo,Bits16);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FBitmap:=TBitmap.Create;
  FSource:=TForwardAudioSource.Create;
  TrackBarChange(nil);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FreeAndnil(FSource);
  FreeAndNil(FBitmap);
end;

procedure TMainForm.TrackBarChange(Sender: TObject);
begin
  PaintBox2.Invalidate;
  with FSource do begin
    Volume:=(TrackBar1.Max-TrackBar1.Position)/TrackBar1.Max;
    Panel1.Caption:=Format('%d',[TrackBar1.Max-TrackBar1.Position]);
    Length:=TrackBar2.Position;
    Panel2.Caption:=Format('Nombre de motifs: %d',[2*TrackBar2.Position]);
    Complexity:=TrackBar3.Position;
    Panel3.Caption:=Format('Complexit: %d',[Complexity]);
    KickBaseFrequency:=TrackBar4.Position;
    Panel4.Caption:=Format('Frquence de base: %d Hz',[TrackBar4.Position]);
    KickAttack:=TrackBar5.Position*10/TrackBar5.Max;
    Panel5.Caption:=Format('Attaque: %.3f',[KickAttack]);
    KickPersistence:=(TrackBar6.Max+TrackBar6.Min-TrackBar6.Position)*10/TrackBar6.Max;
    Panel6.Caption:=Format('Persistance: %.3f',[(TrackBar6.Max+TrackBar6.Min-TrackBar6.Position)*10/TrackBar6.Max]);
    AmplitudeFactor:=TrackBar7.Position/TrackBar7.Max;
    Panel7.Caption:=Format('Rduction d''amplitude: %.3f',[AmplitudeFactor]);
    HarmonicalFactor:=2*TrackBar8.Position/TrackBar8.Max;
    Panel8.Caption:=Format('Dispersion harmonique: %.3f',[HarmonicalFactor]);
    LengthFactor:=TrackBar9.Position/TrackBar9.Max;
    Panel9.Caption:=Format('Rduction de dure: %.3f',[LengthFactor]);
    Speed:=2*TrackBar10.Position/TrackBar10.Max;
    Panel10.Caption:=Format('Vitesse: %.3f',[Speed]);
  end;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  if TabSheet1.Visible then
    PaintBox1Paint(nil);
  ProgressBar1.Position:=Round(ProgressBar1.Max*FSource.LoopTime);
  ProgressBar2.Position:=Round(ProgressBar1.Max*FSource.PatternTime);
end;

procedure TMainForm.PaintBox1Paint(Sender: TObject);
begin
  with PaintBox1 do begin
    FBitmap.Width:=ClientWidth;
    FBitmap.Height:=ClientHeight;
    FSource.PaintLoop(FBitmap.Canvas,ClientWidth,ClientHeight);
    Canvas.Draw(0,0,FBitmap);
  end;
end;

procedure TMainForm.PaintBox2Paint(Sender: TObject);
begin
  with PaintBox2 do
    FSource.PaintKick(Canvas,ClientWidth,ClientHeight);
end;

procedure TMainForm.ActionStartExecute(Sender: TObject);
begin
  WaveOut1.Start;
end;

procedure TMainForm.ActionStopExecute(Sender: TObject);
begin
  WaveOut1.Stop;
end;

procedure TMainForm.ActionConfigureExecute(Sender: TObject);
begin
  DeviceForm.Execute(WaveOut1);
end;

procedure TMainForm.ActionTestExecute(Sender: TObject);
begin
  WaveOut1.Test;
  MessageDlg('Le priphrique semble fonctionner correctement...',mtInformation,[mbOk],0);
end;

procedure TMainForm.ActionAboutExecute(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.WaveOut1Start(Sender: TObject);
begin
  ActionTest.Enabled:=False;
  ActionExport.Enabled:=False;
  SpeedButton2.Glyph:=nil;
  SpeedButton2.Action:=ActionStop;
  MenuItemStartStop.Action:=ActionStop;
end;

procedure TMainForm.WaveOut1Stop(Sender: TObject);
begin
  MenuItemStartStop.Action:=ActionStart;
  SpeedButton2.Glyph:=nil;
  SpeedButton2.Action:=ActionStart;
  ActionExport.Enabled:=True;
  ActionTest.Enabled:=True;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WaveOut1.Stop;
end;

procedure TMainForm.ActionExportExecute(Sender: TObject);
var
  f:TFileStream;
  Frequency:Cardinal;
  Stereo,Bits16:Boolean;
begin
  if WaveForm.Execute(Frequency,Stereo,Bits16) and SaveDialog1.Execute then begin
    f:=TFileStream.Create(SaveDialog1.FileName,fmOpenWrite or fmCreate);
    try
      FSource.ExportToStream(f,Frequency,Stereo,Bits16);
    finally
      f.Destroy;
    end;
  end;
end;

end.

